#ifndef _PUTGET_H
#define _PUTGET_H


#include "types.h"


/*	Basic object putget operations... */
#define	XPUTGET(name, type, bitcnt) \
extern type \
name(register type datum, \
register int source);

XPUTGET(p_putget1u,  uint1,  1)
XPUTGET(p_putget8,    int8,  8)
XPUTGET(p_putget8u,  uint8,  8)
XPUTGET(p_putget16,   int16, 16)
XPUTGET(p_putget16u, uint16, 16)
XPUTGET(p_putget32,   int32, 32)
XPUTGET(p_putget32u, uint32, 32)
XPUTGET(p_putget64,   int64, 64)
XPUTGET(p_putget64u, uint64, 64)
XPUTGET(p_putgetf,      f32, 32)
XPUTGET(p_putgetd,      f64, 64)

#undef	XPUTGET


/*	Bit sequence putget operations...
*/
#define	XPUTGETBITS(name, type) \
extern type \
name(register type datum, \
register int source, \
register int bits);

XPUTGETBITS(p_putgetBits8u,  uint8)
XPUTGETBITS(p_putgetBits16u, uint16)
XPUTGETBITS(p_putgetBits32u, uint32)
XPUTGETBITS(p_putgetBits64u, uint64)

#undef	XPUTGETBITS


#endif
