/*	psetenv.c

	Print a list of commands to appropriately set the PAPERS
	environment variables.

	1995 by Hank Dietz
*/

#include <stdio.h>
#include "intern.h"
#include "version.h"

main()
{

#ifdef	P_VAPERS

	printf("PAPERS_STATFILE=VAPERS_status\nexport PAPERS_STATFILE\n");

#endif

	printf("PAPERS=%s\nexport PAPERS\n", P_PAPERS);
	printf("PAPERS_NPROC=%d\nexport PAPERS_NPROC\n", NPROC);
	printf("# Each workstation is connected to TTL_PAPERS by a\n");
	printf("# Centronics printer port, which is usually at 0x378.\n");
	printf("# If you are using another port address, you will need\n");
	printf("# to change the definition of P_PORTBASE in papers.h.\n");
	printf("PAPERS_PORTBASE=%d\nexport PAPERS_PORTBASE\n", P_PORTBASE);
	printf("# Be sure each PAPERS_IPROC is set appropriately....\n");
	printf("# Using TTL_PAPERS hardware, all the connections to\n");
	printf("# PEs are the same, except for the LEDs, which are not\n");
	printf("# able to be read by the PEs....\n");
	printf("PAPERS_IPROC=%d\nexport PAPERS_IPROC\n", 0);
}
